StatusReadonlyProperties:
  type: object
  properties:
    id:
      type: integer
      description: Идентификатор статуса
      example: 1
  required:
    - id

StatusFillableProperties:
  type: object
  properties:
    name:
      type: string
      description: Имя статуса
      example: Новый
    active:
      type: boolean
      description: Активность
      nullable: true
    default:
      type: boolean
      description: По умолчанию
      nullable: true
    channel:
      type: array
      description: Каналы
      nullable: true
      items:
        type: integer

StatusRequiredFillableProperties:
  type: object
  required:
    - name
    - active
    - default
    - channel

Status:
  allOf:
    - $ref: '#/StatusReadonlyProperties'
    - $ref: '#/StatusFillableProperties'
    - $ref: '#/StatusRequiredFillableProperties'

CreateStatusRequest:
  allOf:
    - $ref: '#/StatusFillableProperties'
    - $ref: '#/StatusRequiredFillableProperties'

PatchStatusRequest:
  allOf:
    - $ref: '#/StatusFillableProperties'

SearchStatusesFilter:
  type: object

SearchStatusesRequest:
  type: object
  properties:
    sort:
      $ref: '../../common_schemas.yaml#/RequestBodySort'
    filter:
      $ref: '#/SearchStatusesFilter'
    include:
      $ref: '../../common_schemas.yaml#/RequestBodyInclude'
    pagination:
      $ref: '../../common_schemas.yaml#/RequestBodyPagination'

StatusResponse:
  type: object
  properties:
    data:
      $ref: '#/Status'
    meta:
      type: object
  required:
    - data

SearchStatusesResponse:
  type: object
  properties:
    data:
      type: array
      items:
        $ref: '#/Status'
    meta:
      type: object
      properties:
        pagination:
          $ref: '../../common_schemas.yaml#/ResponseBodyPagination'
  required:
    - data
    - meta
